Index: trunk/SophyaPI/PIext/graphexecut.h
===================================================================
--- trunk/SophyaPI/PIext/graphexecut.h	(revision 2781)
+++ trunk/SophyaPI/PIext/graphexecut.h	(revision 2781)
@@ -0,0 +1,31 @@
+// This may look like C code, but it is really -*- C++ -*-
+// Classe executeur de commandes graphique pour piapp
+//                                   Reza 05/2005
+// (C) LAL-IN2P3/CNRS  DAPNIA/CEA
+
+#ifndef PIAGraphicExecutor_H_SEEN
+#define PIAGraphicExecutor_H_SEEN
+
+#include "piacmd.h"
+
+class PIAGraphicExecutor : public CmdExecutor {
+public :
+		PIAGraphicExecutor(PIACmd* piac, NamedObjMgr* omg, PIStdImgApp* app);
+  virtual	~PIAGraphicExecutor();
+  virtual int	Execute(string& keyw, vector<string>& args, string& toks);
+  virtual bool  IsThreadable(string const & keyw);
+
+protected :
+  void		RegisterCommands();
+  void          RegisterPIGraphicsHelp(PIACmd* piac);
+  int		BarGraph(string& keyw, vector<string>& args);
+  int		TextDrawer(string& keyw, vector<string>& args);
+
+  PIACmd* mpiac;
+  NamedObjMgr* mObjMgr;
+  PIStdImgApp* mImgApp;
+
+};
+
+
+#endif
Index: trunk/SophyaPI/PIext/objlist.list
===================================================================
--- trunk/SophyaPI/PIext/objlist.list	(revision 2778)
+++ trunk/SophyaPI/PIext/objlist.list	(revision 2781)
@@ -4,4 +4,5 @@
 cxxexecwin.o
 flowmodex.o
+graphexecut.o
 nobjmgr.o
 nomgadapter.o
Index: trunk/SophyaPI/PIext/piacmd.cc
===================================================================
--- trunk/SophyaPI/PIext/piacmd.cc	(revision 2778)
+++ trunk/SophyaPI/PIext/piacmd.cc	(revision 2781)
@@ -6,5 +6,4 @@
 #include <math.h>
 
-#include "basexecut.h"
 
 #include "pdlmgr.h"
@@ -21,4 +20,8 @@
 #include "pistdimgapp.h"
 #include "nobjmgr.h"
+
+// Les differentes classes CommandExecutor
+#include "basexecut.h"
+#include "graphexecut.h"
 #include "piafitting.h"
 #include "pawexecut.h"
@@ -170,4 +173,5 @@
 
 basexec = new PIABaseExecutor(this, mObjMgr, app);
+graphexec = new PIAGraphicExecutor(this, mObjMgr, app);
 fitexec = new PIAFitter(this, app);
 pawexec = new PAWExecutor(this, app);
@@ -197,4 +201,5 @@
 delete cxxoptwin;
 delete basexec;
+delete graphexec;
 delete fitexec;
 delete pawexec;
Index: trunk/SophyaPI/PIext/piacmd.h
===================================================================
--- trunk/SophyaPI/PIext/piacmd.h	(revision 2778)
+++ trunk/SophyaPI/PIext/piacmd.h	(revision 2781)
@@ -72,5 +72,6 @@
   PIStdImgApp* mImgApp;
 
-  CmdExecutor* basexec;  // basic command executor
+  CmdExecutor* basexec;  // base command executor
+  CmdExecutor* graphexec; // graphic command executor
   CmdExecutor* fitexec;  // Fit command executor
   CmdExecutor* pawexec;  // paw-like command executor
Index: trunk/SophyaPI/PIext/servnobjm.cc
===================================================================
--- trunk/SophyaPI/PIext/servnobjm.cc	(revision 2778)
+++ trunk/SophyaPI/PIext/servnobjm.cc	(revision 2781)
@@ -261,8 +261,8 @@
 if (!mImgapp)  return; 
 
-if (npx < 3) npx = 3;
-if (npy < 3) npy = 3;
-if (npx > 250) npx = 250;
-if (npy > 250) npy = 250;
+if (npx < 2) npx = 2;
+if (npy < 2) npy = 2;
+//if (npx > 250) npx = 250;
+//if (npy > 250) npy = 250;
 if (xmax <= xmin) xmax = xmin+1.;
 if (ymax <= ymin) ymax = ymin+1.;
@@ -310,8 +310,13 @@
     }
   else titre = nom;
+  int rsid = 0;
   P2DArrayAdapter* arr = new POMatrixAdapter(mtx, false);
   arr->DefineXYCoordinates(xmin, ymin, dx, dy);
-  PISurfaceDrawer* sdr = new PISurfaceDrawer(arr, true, true, true);
-  int rsid = mImgapp->Disp3DDrawer(sdr, titre, dopt);
+  if ( (npx <= 200) && (npy <= 200) ) {
+    PISurfaceDrawer* sdr = new PISurfaceDrawer(arr, true, true, true);
+    rsid = mImgapp->Disp3DDrawer(sdr, titre, dopt);
+  }
+  else  rsid = mImgapp->DispImage(arr, titre, dopt);
+
   if (nom.length() > 0)  { 
     MyObjMgr()->AddObj(mtx, nom);
